diff --git a/bgpd/bgp_flowspec.c b/bgpd/bgp_flowspec.c
index 70bdbaf0356f..ac370111d6db 100644
--- a/bgpd/bgp_flowspec.c
+++ b/bgpd/bgp_flowspec.c
@@ -196,6 +196,8 @@ int bgp_nlri_parse_flowspec(struct peer *peer, struct attr *attr,
 		else
 			bgp_withdraw(peer, &p, 0, afi, safi, ZEBRA_ROUTE_BGP,
 				     BGP_ROUTE_NORMAL, NULL, NULL, 0, NULL);
+
+			XFREE(MTYPE_TMP, temp);
 	}
 	return BGP_NLRI_PARSE_OK;
 }
